
import java.util.ArrayList;
import java.util.List;

public class Choice implements Parser {
	public Parser p1;
	public Parser p2;
	
	public Choice(Parser _p1, Parser _p2) {
		p1 = _p1;
		p2 = _p2;
	}

	public Choice(Parser... ps) {
		if(ps.length < 2)
			throw new RuntimeException("choice precisa de pelo menos dois elementos");
		p1 = ps[0];
		if(ps.length == 2) {
			p2 = ps[1];
		} else {
			Parser[] nps = new Parser[ps.length-1];
			for(int i = 1; i < ps.length; i++) {
				nps[i-1] = ps[i];
			}
			p2 = new Choice(nps);
		}
	}

	@Override
	public List<List<Token>> parse(List<Token> input) {
		List<List<Token>> res1 = p1.parse(input);
		List<List<Token>> res2 = p2.parse(input);
		ArrayList<List<Token>> res = new ArrayList<>();
		res.addAll(res1);
		res.addAll(res2);
		return res;
	}

}
